Why doesn't using multiple commands with a || or && conditional work?How can I test if a variable is empty or contains only spaces?Using sshpass, return code (exit status) differs for reasons unknown using valid commandsScript in C shell skipping over last else statement?Modify bash arguments if only one argument is setFunction that calls another function with list of arguments doesn't workC Shell Script syntax error “unexpected end of of file”“dash” arguments to shell scriptsHow to use as argument the characters + , - , x , / in a scriptCreate a menu driven script with do loop and case statement in bashA star is being printed for an empty directory after running a script to list the subfolderecho $HISTSIZE not printing when executed via shell script but works in command line

Madden-Julian Oscillation (MJO) - How to interpret the index?

How to show a landlord what we have in savings?

What does the expression "A Mann!" means

iPad being using in wall mount battery swollen

What does “the session was packed” mean in this context?

When (not how or why) to calculate Big O of an algorithm

Is it inappropriate for a student to attend their mentor's dissertation defense?

How seriously should I take size and weight limits of hand luggage?

How can saying a song's name be a copyright violation?

What are some good books on Machine Learning and AI like Krugman, Wells and Graddy's "Essentials of Economics"

Different meanings of こわい

Apex Framework / library for consuming REST services

Plagiarism or not?

Is "remove commented out code" correct English?

Unlock My Phone! February 2018

CAST throwing error when run in stored procedure but not when run as raw query

What's the in-universe reasoning behind sorcerers needing material components?

One verb to replace 'be a member of' a club

Does the Idaho Potato Commission associate potato skins with healthy eating?

Is this a hacking script in function.php?

Is there a hemisphere-neutral way of specifying a season?

What about the virus in 12 Monkeys?

Why is it a bad idea to hire a hitman to eliminate most corrupt politicians?

How badly should I try to prevent a user from XSSing themselves?



Why doesn't using multiple commands with a || or && conditional work?


How can I test if a variable is empty or contains only spaces?Using sshpass, return code (exit status) differs for reasons unknown using valid commandsScript in C shell skipping over last else statement?Modify bash arguments if only one argument is setFunction that calls another function with list of arguments doesn't workC Shell Script syntax error “unexpected end of of file”“dash” arguments to shell scriptsHow to use as argument the characters + , - , x , / in a scriptCreate a menu driven script with do loop and case statement in bashA star is being printed for an empty directory after running a script to list the subfolderecho $HISTSIZE not printing when executed via shell script but works in command line













8

















This works on a shell (bash, dash) prompt:



[ -z "" ] && echo A || echo B
A


However, I am trying to write a POSIX shell script, it starts like this:



#!/bin/sh

[ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1

readonly raw_input_string=$1

[ -z "$raw_input_string" ] && echo "The given argument is empty."; exit 1


And I don't know why, but I don't get the message:




The given argument is empty.




if I call the script like this:



./test_empty_argument ""


Why is that?










share|improve this question



















  • 3





    See How can I test if a variable is empty or contains only spaces? for ways on testing if a variable is empty, unset, or only contains blanks. The issue in this question has nothing to do with that.

    – ilkkachu
    4 hours ago












  • Just use if [ X”” = X”$var” ] ; then echo isempty ; fi

    – user2497
    4 hours ago











  • @user2497 There is no reason to use that in any shell released in the last 20 years. That's a workaround for old, buggy shells.

    – chepner
    3 hours ago












  • @chepner So it is not a valid solution? Something else must be used?

    – user2497
    3 hours ago






  • 2





    [ "" = "$var" ] would work fine; a quoted empty string will not be removed from the argument list of [. But that's not necessary either, because [ -z "$var" ] also works just fine.

    – chepner
    3 hours ago
















8

















This works on a shell (bash, dash) prompt:



[ -z "" ] && echo A || echo B
A


However, I am trying to write a POSIX shell script, it starts like this:



#!/bin/sh

[ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1

readonly raw_input_string=$1

[ -z "$raw_input_string" ] && echo "The given argument is empty."; exit 1


And I don't know why, but I don't get the message:




The given argument is empty.




if I call the script like this:



./test_empty_argument ""


Why is that?










share|improve this question



















  • 3





    See How can I test if a variable is empty or contains only spaces? for ways on testing if a variable is empty, unset, or only contains blanks. The issue in this question has nothing to do with that.

    – ilkkachu
    4 hours ago












  • Just use if [ X”” = X”$var” ] ; then echo isempty ; fi

    – user2497
    4 hours ago











  • @user2497 There is no reason to use that in any shell released in the last 20 years. That's a workaround for old, buggy shells.

    – chepner
    3 hours ago












  • @chepner So it is not a valid solution? Something else must be used?

    – user2497
    3 hours ago






  • 2





    [ "" = "$var" ] would work fine; a quoted empty string will not be removed from the argument list of [. But that's not necessary either, because [ -z "$var" ] also works just fine.

    – chepner
    3 hours ago














8












8








8










This works on a shell (bash, dash) prompt:



[ -z "" ] && echo A || echo B
A


However, I am trying to write a POSIX shell script, it starts like this:



#!/bin/sh

[ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1

readonly raw_input_string=$1

[ -z "$raw_input_string" ] && echo "The given argument is empty."; exit 1


And I don't know why, but I don't get the message:




The given argument is empty.




if I call the script like this:



./test_empty_argument ""


Why is that?










share|improve this question


















This works on a shell (bash, dash) prompt:



[ -z "" ] && echo A || echo B
A


However, I am trying to write a POSIX shell script, it starts like this:



#!/bin/sh

[ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1

readonly raw_input_string=$1

[ -z "$raw_input_string" ] && echo "The given argument is empty."; exit 1


And I don't know why, but I don't get the message:




The given argument is empty.




if I call the script like this:



./test_empty_argument ""


Why is that?







shell-script arguments






share|improve this question















share|improve this question













share|improve this question




share|improve this question








edited 1 hour ago









ilkkachu

63k10103180




63k10103180










asked 15 hours ago









VlastimilVlastimil

8,4151565145




8,4151565145







  • 3





    See How can I test if a variable is empty or contains only spaces? for ways on testing if a variable is empty, unset, or only contains blanks. The issue in this question has nothing to do with that.

    – ilkkachu
    4 hours ago












  • Just use if [ X”” = X”$var” ] ; then echo isempty ; fi

    – user2497
    4 hours ago











  • @user2497 There is no reason to use that in any shell released in the last 20 years. That's a workaround for old, buggy shells.

    – chepner
    3 hours ago












  • @chepner So it is not a valid solution? Something else must be used?

    – user2497
    3 hours ago






  • 2





    [ "" = "$var" ] would work fine; a quoted empty string will not be removed from the argument list of [. But that's not necessary either, because [ -z "$var" ] also works just fine.

    – chepner
    3 hours ago













  • 3





    See How can I test if a variable is empty or contains only spaces? for ways on testing if a variable is empty, unset, or only contains blanks. The issue in this question has nothing to do with that.

    – ilkkachu
    4 hours ago












  • Just use if [ X”” = X”$var” ] ; then echo isempty ; fi

    – user2497
    4 hours ago











  • @user2497 There is no reason to use that in any shell released in the last 20 years. That's a workaround for old, buggy shells.

    – chepner
    3 hours ago












  • @chepner So it is not a valid solution? Something else must be used?

    – user2497
    3 hours ago






  • 2





    [ "" = "$var" ] would work fine; a quoted empty string will not be removed from the argument list of [. But that's not necessary either, because [ -z "$var" ] also works just fine.

    – chepner
    3 hours ago








3




3





See How can I test if a variable is empty or contains only spaces? for ways on testing if a variable is empty, unset, or only contains blanks. The issue in this question has nothing to do with that.

– ilkkachu
4 hours ago






See How can I test if a variable is empty or contains only spaces? for ways on testing if a variable is empty, unset, or only contains blanks. The issue in this question has nothing to do with that.

– ilkkachu
4 hours ago














Just use if [ X”” = X”$var” ] ; then echo isempty ; fi

– user2497
4 hours ago





Just use if [ X”” = X”$var” ] ; then echo isempty ; fi

– user2497
4 hours ago













@user2497 There is no reason to use that in any shell released in the last 20 years. That's a workaround for old, buggy shells.

– chepner
3 hours ago






@user2497 There is no reason to use that in any shell released in the last 20 years. That's a workaround for old, buggy shells.

– chepner
3 hours ago














@chepner So it is not a valid solution? Something else must be used?

– user2497
3 hours ago





@chepner So it is not a valid solution? Something else must be used?

– user2497
3 hours ago




2




2





[ "" = "$var" ] would work fine; a quoted empty string will not be removed from the argument list of [. But that's not necessary either, because [ -z "$var" ] also works just fine.

– chepner
3 hours ago






[ "" = "$var" ] would work fine; a quoted empty string will not be removed from the argument list of [. But that's not necessary either, because [ -z "$var" ] also works just fine.

– chepner
3 hours ago











5 Answers
5






active

oldest

votes


















22














Note that your line



[ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


this is the same as



[ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."
exit 1


(a ; can, in most circumstances, be replaced by a newline character)



Which means that the exit 1 statement is always executed regardless of how many arguments were passed to the script. This means that the message The given argument is empty. would never have a chance of getting printed.



To execute more than a single statement after a test using the "short-circuit syntax", group the statements in ...; . The alternative is to use a proper if test (which, IMHO, looks cleaner in a script):



if [ "$#" -ne 1 ]; then
echo 'Invalid number of arguments, expected one.' >&2
exit 1
fi


You have the same issue with your second test.




Regarding



[ -z "" ] && echo A || echo B


This would work for the given example, but the generic



some-test && command1 || command2


would not be the same as



if some-test; then
command1
else
command2
fi


Instead, it is more like



if ! some-test && command1; ; then
command2
fi


That is, if either the test or the first command fails, the second command executes, which means it has the potential to execute all three involved statements.






share|improve this answer
































    10














    This:



    [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


    is not:



    [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1; 


    But instead is:



     [ "$#" -eq 1 ] 
    exit 1


    Your script is exiting regardless of how many arguments you passed to it.






    share|improve this answer






























      1














      One way to make it more readable is to define a die function (à la perl) like:



      die() 
      printf >&2 '%sn' "$@"
      exit 1


      # then:

      [ "$#" -eq 1 ] || die "Expected one argument, got $#"

      [ -n "$1" ] || die "Empty argument not supported"


      You can add more bells and whistles like colours, prefix... if need be.






      share|improve this answer























      • In practice, do you ever call your die function with multiple arguments? (If so, can you give an example?) I use an almost identical die function, but use "$*" instead, which may be more what you're intending?

        – jrw32982
        3 hours ago











      • The value of "$@" is that it allows multi-line messages without needing to add literal newlines.

        – Charles Duffy
        1 hour ago


















      0














      I've often seen this as a test for an empty string:



      if [ "x$foo" = "x" ]; then ...





      share|improve this answer

























      • Should have been "=" - fixed.

        – wef
        15 hours ago











      • That practice is literally from the 1970s. There is no reason whatsoever to use it with any shell that is compliant with the 1992 POSIX sh standard (so long as correct quoting is used and now-obsolescent functionality such as -a, -o, ( and ) as derectives to tell test to combine multiple operations in a single invocation are avoided; see the OB markers in pubs.opengroup.org/onlinepubs/9699919799/utilities/test.html).

        – Charles Duffy
        1 hour ago



















      0














      I would also add to the other answers that a POSIX shell may detect variable assignment errors.



      #!/bin/sh -u

      foo=$1:? # choose a meaninful variable name and possibly use an error message.
      # ... if the first parameter is unset or empty the shell exits.
      bar=$2- # if the second parameter is set, then the shell assigns its value, else
      # it assigns the empty string.

      # displays the date if "var" is empty, else, prints the working directory.
      [ -z "$var-" ] && date || pwd

      # "var" is set to the empty string. I assume the nineth parameter is not set.
      # `echo "$9"' returns 1 so the shell also runs `echo "var not empty: $var"'
      [ -z "$var-" ] && echo "$9" || echo "var not empty: $var"

      # `echo "var empty"' returns 0
      [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"

      var=0101

      [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"


      The shell exits if any variable is unset while the shell option -u is enabled. The shell expansions used in the sample script are also defined by POSIX.






      share|improve this answer

























        Your Answer








        StackExchange.ready(function()
        var channelOptions =
        tags: "".split(" "),
        id: "106"
        ;
        initTagRenderer("".split(" "), "".split(" "), channelOptions);

        StackExchange.using("externalEditor", function()
        // Have to fire editor after snippets, if snippets enabled
        if (StackExchange.settings.snippets.snippetsEnabled)
        StackExchange.using("snippets", function()
        createEditor();
        );

        else
        createEditor();

        );

        function createEditor()
        StackExchange.prepareEditor(
        heartbeatType: 'answer',
        autoActivateHeartbeat: false,
        convertImagesToLinks: false,
        noModals: true,
        showLowRepImageUploadWarning: true,
        reputationToPostImages: null,
        bindNavPrevention: true,
        postfix: "",
        imageUploader:
        brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
        contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
        allowUrls: true
        ,
        onDemand: true,
        discardSelector: ".discard-answer"
        ,immediatelyShowMarkdownHelp:true
        );



        );













        draft saved

        draft discarded


















        StackExchange.ready(
        function ()
        StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f510216%2fwhy-doesnt-using-multiple-commands-with-a-or-conditional-work%23new-answer', 'question_page');

        );

        Post as a guest















        Required, but never shown

























        5 Answers
        5






        active

        oldest

        votes








        5 Answers
        5






        active

        oldest

        votes









        active

        oldest

        votes






        active

        oldest

        votes









        22














        Note that your line



        [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


        this is the same as



        [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."
        exit 1


        (a ; can, in most circumstances, be replaced by a newline character)



        Which means that the exit 1 statement is always executed regardless of how many arguments were passed to the script. This means that the message The given argument is empty. would never have a chance of getting printed.



        To execute more than a single statement after a test using the "short-circuit syntax", group the statements in ...; . The alternative is to use a proper if test (which, IMHO, looks cleaner in a script):



        if [ "$#" -ne 1 ]; then
        echo 'Invalid number of arguments, expected one.' >&2
        exit 1
        fi


        You have the same issue with your second test.




        Regarding



        [ -z "" ] && echo A || echo B


        This would work for the given example, but the generic



        some-test && command1 || command2


        would not be the same as



        if some-test; then
        command1
        else
        command2
        fi


        Instead, it is more like



        if ! some-test && command1; ; then
        command2
        fi


        That is, if either the test or the first command fails, the second command executes, which means it has the potential to execute all three involved statements.






        share|improve this answer





























          22














          Note that your line



          [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


          this is the same as



          [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."
          exit 1


          (a ; can, in most circumstances, be replaced by a newline character)



          Which means that the exit 1 statement is always executed regardless of how many arguments were passed to the script. This means that the message The given argument is empty. would never have a chance of getting printed.



          To execute more than a single statement after a test using the "short-circuit syntax", group the statements in ...; . The alternative is to use a proper if test (which, IMHO, looks cleaner in a script):



          if [ "$#" -ne 1 ]; then
          echo 'Invalid number of arguments, expected one.' >&2
          exit 1
          fi


          You have the same issue with your second test.




          Regarding



          [ -z "" ] && echo A || echo B


          This would work for the given example, but the generic



          some-test && command1 || command2


          would not be the same as



          if some-test; then
          command1
          else
          command2
          fi


          Instead, it is more like



          if ! some-test && command1; ; then
          command2
          fi


          That is, if either the test or the first command fails, the second command executes, which means it has the potential to execute all three involved statements.






          share|improve this answer



























            22












            22








            22







            Note that your line



            [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


            this is the same as



            [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."
            exit 1


            (a ; can, in most circumstances, be replaced by a newline character)



            Which means that the exit 1 statement is always executed regardless of how many arguments were passed to the script. This means that the message The given argument is empty. would never have a chance of getting printed.



            To execute more than a single statement after a test using the "short-circuit syntax", group the statements in ...; . The alternative is to use a proper if test (which, IMHO, looks cleaner in a script):



            if [ "$#" -ne 1 ]; then
            echo 'Invalid number of arguments, expected one.' >&2
            exit 1
            fi


            You have the same issue with your second test.




            Regarding



            [ -z "" ] && echo A || echo B


            This would work for the given example, but the generic



            some-test && command1 || command2


            would not be the same as



            if some-test; then
            command1
            else
            command2
            fi


            Instead, it is more like



            if ! some-test && command1; ; then
            command2
            fi


            That is, if either the test or the first command fails, the second command executes, which means it has the potential to execute all three involved statements.






            share|improve this answer















            Note that your line



            [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


            this is the same as



            [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."
            exit 1


            (a ; can, in most circumstances, be replaced by a newline character)



            Which means that the exit 1 statement is always executed regardless of how many arguments were passed to the script. This means that the message The given argument is empty. would never have a chance of getting printed.



            To execute more than a single statement after a test using the "short-circuit syntax", group the statements in ...; . The alternative is to use a proper if test (which, IMHO, looks cleaner in a script):



            if [ "$#" -ne 1 ]; then
            echo 'Invalid number of arguments, expected one.' >&2
            exit 1
            fi


            You have the same issue with your second test.




            Regarding



            [ -z "" ] && echo A || echo B


            This would work for the given example, but the generic



            some-test && command1 || command2


            would not be the same as



            if some-test; then
            command1
            else
            command2
            fi


            Instead, it is more like



            if ! some-test && command1; ; then
            command2
            fi


            That is, if either the test or the first command fails, the second command executes, which means it has the potential to execute all three involved statements.







            share|improve this answer














            share|improve this answer



            share|improve this answer








            edited 50 mins ago

























            answered 15 hours ago









            KusalanandaKusalananda

            139k17259431




            139k17259431























                10














                This:



                [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


                is not:



                [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1; 


                But instead is:



                 [ "$#" -eq 1 ] 
                exit 1


                Your script is exiting regardless of how many arguments you passed to it.






                share|improve this answer



























                  10














                  This:



                  [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


                  is not:



                  [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1; 


                  But instead is:



                   [ "$#" -eq 1 ] 
                  exit 1


                  Your script is exiting regardless of how many arguments you passed to it.






                  share|improve this answer

























                    10












                    10








                    10







                    This:



                    [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


                    is not:



                    [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1; 


                    But instead is:



                     [ "$#" -eq 1 ] 
                    exit 1


                    Your script is exiting regardless of how many arguments you passed to it.






                    share|improve this answer













                    This:



                    [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1


                    is not:



                    [ "$#" -eq 1 ] || echo "Invalid number of arguments, expected one."; exit 1; 


                    But instead is:



                     [ "$#" -eq 1 ] 
                    exit 1


                    Your script is exiting regardless of how many arguments you passed to it.







                    share|improve this answer












                    share|improve this answer



                    share|improve this answer










                    answered 15 hours ago









                    murumuru

                    37k589164




                    37k589164





















                        1














                        One way to make it more readable is to define a die function (à la perl) like:



                        die() 
                        printf >&2 '%sn' "$@"
                        exit 1


                        # then:

                        [ "$#" -eq 1 ] || die "Expected one argument, got $#"

                        [ -n "$1" ] || die "Empty argument not supported"


                        You can add more bells and whistles like colours, prefix... if need be.






                        share|improve this answer























                        • In practice, do you ever call your die function with multiple arguments? (If so, can you give an example?) I use an almost identical die function, but use "$*" instead, which may be more what you're intending?

                          – jrw32982
                          3 hours ago











                        • The value of "$@" is that it allows multi-line messages without needing to add literal newlines.

                          – Charles Duffy
                          1 hour ago















                        1














                        One way to make it more readable is to define a die function (à la perl) like:



                        die() 
                        printf >&2 '%sn' "$@"
                        exit 1


                        # then:

                        [ "$#" -eq 1 ] || die "Expected one argument, got $#"

                        [ -n "$1" ] || die "Empty argument not supported"


                        You can add more bells and whistles like colours, prefix... if need be.






                        share|improve this answer























                        • In practice, do you ever call your die function with multiple arguments? (If so, can you give an example?) I use an almost identical die function, but use "$*" instead, which may be more what you're intending?

                          – jrw32982
                          3 hours ago











                        • The value of "$@" is that it allows multi-line messages without needing to add literal newlines.

                          – Charles Duffy
                          1 hour ago













                        1












                        1








                        1







                        One way to make it more readable is to define a die function (à la perl) like:



                        die() 
                        printf >&2 '%sn' "$@"
                        exit 1


                        # then:

                        [ "$#" -eq 1 ] || die "Expected one argument, got $#"

                        [ -n "$1" ] || die "Empty argument not supported"


                        You can add more bells and whistles like colours, prefix... if need be.






                        share|improve this answer













                        One way to make it more readable is to define a die function (à la perl) like:



                        die() 
                        printf >&2 '%sn' "$@"
                        exit 1


                        # then:

                        [ "$#" -eq 1 ] || die "Expected one argument, got $#"

                        [ -n "$1" ] || die "Empty argument not supported"


                        You can add more bells and whistles like colours, prefix... if need be.







                        share|improve this answer












                        share|improve this answer



                        share|improve this answer










                        answered 5 hours ago









                        Stéphane ChazelasStéphane Chazelas

                        312k57592948




                        312k57592948












                        • In practice, do you ever call your die function with multiple arguments? (If so, can you give an example?) I use an almost identical die function, but use "$*" instead, which may be more what you're intending?

                          – jrw32982
                          3 hours ago











                        • The value of "$@" is that it allows multi-line messages without needing to add literal newlines.

                          – Charles Duffy
                          1 hour ago

















                        • In practice, do you ever call your die function with multiple arguments? (If so, can you give an example?) I use an almost identical die function, but use "$*" instead, which may be more what you're intending?

                          – jrw32982
                          3 hours ago











                        • The value of "$@" is that it allows multi-line messages without needing to add literal newlines.

                          – Charles Duffy
                          1 hour ago
















                        In practice, do you ever call your die function with multiple arguments? (If so, can you give an example?) I use an almost identical die function, but use "$*" instead, which may be more what you're intending?

                        – jrw32982
                        3 hours ago





                        In practice, do you ever call your die function with multiple arguments? (If so, can you give an example?) I use an almost identical die function, but use "$*" instead, which may be more what you're intending?

                        – jrw32982
                        3 hours ago













                        The value of "$@" is that it allows multi-line messages without needing to add literal newlines.

                        – Charles Duffy
                        1 hour ago





                        The value of "$@" is that it allows multi-line messages without needing to add literal newlines.

                        – Charles Duffy
                        1 hour ago











                        0














                        I've often seen this as a test for an empty string:



                        if [ "x$foo" = "x" ]; then ...





                        share|improve this answer

























                        • Should have been "=" - fixed.

                          – wef
                          15 hours ago











                        • That practice is literally from the 1970s. There is no reason whatsoever to use it with any shell that is compliant with the 1992 POSIX sh standard (so long as correct quoting is used and now-obsolescent functionality such as -a, -o, ( and ) as derectives to tell test to combine multiple operations in a single invocation are avoided; see the OB markers in pubs.opengroup.org/onlinepubs/9699919799/utilities/test.html).

                          – Charles Duffy
                          1 hour ago
















                        0














                        I've often seen this as a test for an empty string:



                        if [ "x$foo" = "x" ]; then ...





                        share|improve this answer

























                        • Should have been "=" - fixed.

                          – wef
                          15 hours ago











                        • That practice is literally from the 1970s. There is no reason whatsoever to use it with any shell that is compliant with the 1992 POSIX sh standard (so long as correct quoting is used and now-obsolescent functionality such as -a, -o, ( and ) as derectives to tell test to combine multiple operations in a single invocation are avoided; see the OB markers in pubs.opengroup.org/onlinepubs/9699919799/utilities/test.html).

                          – Charles Duffy
                          1 hour ago














                        0












                        0








                        0







                        I've often seen this as a test for an empty string:



                        if [ "x$foo" = "x" ]; then ...





                        share|improve this answer















                        I've often seen this as a test for an empty string:



                        if [ "x$foo" = "x" ]; then ...






                        share|improve this answer














                        share|improve this answer



                        share|improve this answer








                        edited 15 hours ago

























                        answered 15 hours ago









                        wefwef

                        31415




                        31415












                        • Should have been "=" - fixed.

                          – wef
                          15 hours ago











                        • That practice is literally from the 1970s. There is no reason whatsoever to use it with any shell that is compliant with the 1992 POSIX sh standard (so long as correct quoting is used and now-obsolescent functionality such as -a, -o, ( and ) as derectives to tell test to combine multiple operations in a single invocation are avoided; see the OB markers in pubs.opengroup.org/onlinepubs/9699919799/utilities/test.html).

                          – Charles Duffy
                          1 hour ago


















                        • Should have been "=" - fixed.

                          – wef
                          15 hours ago











                        • That practice is literally from the 1970s. There is no reason whatsoever to use it with any shell that is compliant with the 1992 POSIX sh standard (so long as correct quoting is used and now-obsolescent functionality such as -a, -o, ( and ) as derectives to tell test to combine multiple operations in a single invocation are avoided; see the OB markers in pubs.opengroup.org/onlinepubs/9699919799/utilities/test.html).

                          – Charles Duffy
                          1 hour ago

















                        Should have been "=" - fixed.

                        – wef
                        15 hours ago





                        Should have been "=" - fixed.

                        – wef
                        15 hours ago













                        That practice is literally from the 1970s. There is no reason whatsoever to use it with any shell that is compliant with the 1992 POSIX sh standard (so long as correct quoting is used and now-obsolescent functionality such as -a, -o, ( and ) as derectives to tell test to combine multiple operations in a single invocation are avoided; see the OB markers in pubs.opengroup.org/onlinepubs/9699919799/utilities/test.html).

                        – Charles Duffy
                        1 hour ago






                        That practice is literally from the 1970s. There is no reason whatsoever to use it with any shell that is compliant with the 1992 POSIX sh standard (so long as correct quoting is used and now-obsolescent functionality such as -a, -o, ( and ) as derectives to tell test to combine multiple operations in a single invocation are avoided; see the OB markers in pubs.opengroup.org/onlinepubs/9699919799/utilities/test.html).

                        – Charles Duffy
                        1 hour ago












                        0














                        I would also add to the other answers that a POSIX shell may detect variable assignment errors.



                        #!/bin/sh -u

                        foo=$1:? # choose a meaninful variable name and possibly use an error message.
                        # ... if the first parameter is unset or empty the shell exits.
                        bar=$2- # if the second parameter is set, then the shell assigns its value, else
                        # it assigns the empty string.

                        # displays the date if "var" is empty, else, prints the working directory.
                        [ -z "$var-" ] && date || pwd

                        # "var" is set to the empty string. I assume the nineth parameter is not set.
                        # `echo "$9"' returns 1 so the shell also runs `echo "var not empty: $var"'
                        [ -z "$var-" ] && echo "$9" || echo "var not empty: $var"

                        # `echo "var empty"' returns 0
                        [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"

                        var=0101

                        [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"


                        The shell exits if any variable is unset while the shell option -u is enabled. The shell expansions used in the sample script are also defined by POSIX.






                        share|improve this answer





























                          0














                          I would also add to the other answers that a POSIX shell may detect variable assignment errors.



                          #!/bin/sh -u

                          foo=$1:? # choose a meaninful variable name and possibly use an error message.
                          # ... if the first parameter is unset or empty the shell exits.
                          bar=$2- # if the second parameter is set, then the shell assigns its value, else
                          # it assigns the empty string.

                          # displays the date if "var" is empty, else, prints the working directory.
                          [ -z "$var-" ] && date || pwd

                          # "var" is set to the empty string. I assume the nineth parameter is not set.
                          # `echo "$9"' returns 1 so the shell also runs `echo "var not empty: $var"'
                          [ -z "$var-" ] && echo "$9" || echo "var not empty: $var"

                          # `echo "var empty"' returns 0
                          [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"

                          var=0101

                          [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"


                          The shell exits if any variable is unset while the shell option -u is enabled. The shell expansions used in the sample script are also defined by POSIX.






                          share|improve this answer



























                            0












                            0








                            0







                            I would also add to the other answers that a POSIX shell may detect variable assignment errors.



                            #!/bin/sh -u

                            foo=$1:? # choose a meaninful variable name and possibly use an error message.
                            # ... if the first parameter is unset or empty the shell exits.
                            bar=$2- # if the second parameter is set, then the shell assigns its value, else
                            # it assigns the empty string.

                            # displays the date if "var" is empty, else, prints the working directory.
                            [ -z "$var-" ] && date || pwd

                            # "var" is set to the empty string. I assume the nineth parameter is not set.
                            # `echo "$9"' returns 1 so the shell also runs `echo "var not empty: $var"'
                            [ -z "$var-" ] && echo "$9" || echo "var not empty: $var"

                            # `echo "var empty"' returns 0
                            [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"

                            var=0101

                            [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"


                            The shell exits if any variable is unset while the shell option -u is enabled. The shell expansions used in the sample script are also defined by POSIX.






                            share|improve this answer















                            I would also add to the other answers that a POSIX shell may detect variable assignment errors.



                            #!/bin/sh -u

                            foo=$1:? # choose a meaninful variable name and possibly use an error message.
                            # ... if the first parameter is unset or empty the shell exits.
                            bar=$2- # if the second parameter is set, then the shell assigns its value, else
                            # it assigns the empty string.

                            # displays the date if "var" is empty, else, prints the working directory.
                            [ -z "$var-" ] && date || pwd

                            # "var" is set to the empty string. I assume the nineth parameter is not set.
                            # `echo "$9"' returns 1 so the shell also runs `echo "var not empty: $var"'
                            [ -z "$var-" ] && echo "$9" || echo "var not empty: $var"

                            # `echo "var empty"' returns 0
                            [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"

                            var=0101

                            [ -z "$var-" ] && echo "var empty" || echo "var not empty: $var"


                            The shell exits if any variable is unset while the shell option -u is enabled. The shell expansions used in the sample script are also defined by POSIX.







                            share|improve this answer














                            share|improve this answer



                            share|improve this answer








                            edited 5 hours ago

























                            answered 5 hours ago









                            FólkvangrFólkvangr

                            32913




                            32913



























                                draft saved

                                draft discarded
















































                                Thanks for contributing an answer to Unix & Linux Stack Exchange!


                                • Please be sure to answer the question. Provide details and share your research!

                                But avoid


                                • Asking for help, clarification, or responding to other answers.

                                • Making statements based on opinion; back them up with references or personal experience.

                                To learn more, see our tips on writing great answers.




                                draft saved


                                draft discarded














                                StackExchange.ready(
                                function ()
                                StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f510216%2fwhy-doesnt-using-multiple-commands-with-a-or-conditional-work%23new-answer', 'question_page');

                                );

                                Post as a guest















                                Required, but never shown





















































                                Required, but never shown














                                Required, but never shown












                                Required, but never shown







                                Required, but never shown

































                                Required, but never shown














                                Required, but never shown












                                Required, but never shown







                                Required, but never shown







                                Popular posts from this blog

                                Ружовы пелікан Змест Знешні выгляд | Пашырэнне | Асаблівасці біялогіі | Літаратура | НавігацыяДагледжаная версіяправерана1 зменаДагледжаная версіяправерана1 змена/ 22697590 Сістэматыкана ВіківідахВыявына Вікісховішчы174693363011049382

                                ValueError: Error when checking input: expected conv2d_13_input to have shape (3, 150, 150) but got array with shape (150, 150, 3)2019 Community Moderator ElectionError when checking : expected dense_1_input to have shape (None, 5) but got array with shape (200, 1)Error 'Expected 2D array, got 1D array instead:'ValueError: Error when checking input: expected lstm_41_input to have 3 dimensions, but got array with shape (40000,100)ValueError: Error when checking target: expected dense_1 to have shape (7,) but got array with shape (1,)ValueError: Error when checking target: expected dense_2 to have shape (1,) but got array with shape (0,)Keras exception: ValueError: Error when checking input: expected conv2d_1_input to have shape (150, 150, 3) but got array with shape (256, 256, 3)Steps taking too long to completewhen checking input: expected dense_1_input to have shape (13328,) but got array with shape (317,)ValueError: Error when checking target: expected dense_3 to have shape (None, 1) but got array with shape (7715, 40000)Keras exception: Error when checking input: expected dense_input to have shape (2,) but got array with shape (1,)

                                Illegal assignment from SObject to ContactFetching String, Id from Map - Illegal Assignment Id to Field / ObjectError: Compile Error: Illegal assignment from String to BooleanError: List has no rows for assignment to SObjectError on Test Class - System.QueryException: List has no rows for assignment to SObjectRemote action problemDML requires SObject or SObject list type error“Illegal assignment from List to List”Test Class Fail: Batch Class: System.QueryException: List has no rows for assignment to SObjectMapping to a user'List has no rows for assignment to SObject' Mystery